#include <Windows.h>

#include <cstdio>

int main(int argc, char** argv) {
  if (argc != 2) {
    printf("Usage: %s <hive file>\n", argv[0]);
    return 1;
  }

  LONG st = ERROR_SUCCESS;
  HKEY hkey, hnewkey;

  do {
    st = RegLoadAppKeyA(argv[1], &hkey, KEY_ALL_ACCESS, 0, 0);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Hive successfully loaded\n");

    st = RegCreateKeyExA(hkey, "NewSubKey", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hnewkey, NULL);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key successfully created\n");

    st = RegDeleteKeyA(hkey, "NewSubKey");
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Key successfully deleted\n");

    st = RegCloseKey(hkey);
    if (st != ERROR_SUCCESS) {
      break;
    }
  } while (0);

  if (st != ERROR_SUCCESS) {
    printf("Call failed with error %d\n", st);
  }

  return 0;
}
