using System;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Security.Cryptography.Xml;
using System.Xml;

XmlReaderSettings settings = new XmlReaderSettings();
settings.DtdProcessing = DtdProcessing.Prohibit; // Protect against XXE
settings.XmlResolver = null; // No XXE
XmlReader reader = XmlReader.Create("test_signed.xml", settings: settings);
            
// Create a new XML document.
XmlDocument xmlDoc = new XmlDocument();

// Load an XML file into the XmlDocument object.
xmlDoc.PreserveWhitespace = true;
xmlDoc.Load(reader);

// Verify the signature of the signed XML.
Console.WriteLine("Verifying signature...");

// Create a new SignedXml object and pass it
// the XML document class.
SignedXml signedXml = new SignedXml(xmlDoc);

// Find the "Signature" node and create a new
// XmlNodeList object.
XmlNodeList nodeList = xmlDoc.GetElementsByTagName("Signature");

// Throw an exception if no signature was found.
if (nodeList.Count <= 0)
{
    throw new CryptographicException("Verification failed: No Signature was found in the document.");
}

signedXml.LoadXml((XmlElement)nodeList[0]);

signedXml.CheckSignature();


